Attribute VB_Name = "Module1"
'RRPB.bas

DefLng A-W     ' All variables Long Integer apart
DefSng X-Z     ' from those starting with X to Z

' --------------------------------------------------------------
' Windows API - For blitting one image to another location

Public Declare Function BitBlt Lib "gdi32" _
(ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, _
ByVal nWidth As Long, ByVal nHeight As Long, _
ByVal hSrcDC As Long, ByVal XSrc As Long, ByVal YSrc As Long, _
ByVal dwRop As Long) As Long


' --------------------------------------------------------------
' Windows 98 API - For transparent blitting

Public Declare Function TransparentBlt Lib "msimg32" _
   (ByVal hdcDest As Long, _
    ByVal nXOriginDest As Long, ByVal nYOriginDest As Long, _
    ByVal nWidthDest As Long, ByVal nHeightDest As Long, _
    ByVal hdcSrc As Long, _
    ByVal nXOriginSrc As Long, ByVal nYOriginSrc As Long, _
    ByVal nWidthSrc As Long, ByVal nHeightSrc As Long, _
    ByVal crTransparent As Long) As Long

' --------------------------------------------------------------
' Windows API - For matching top of board to Form backcolor
' NB  Important to be sure RGB values for Form &
'     PicBoard are valid.  ie some RGB components in 16-bit
'     color are dithered by VB whence this API will not work
'     24 or 32-bit color should be OK.

Public Declare Function ExtFloodFill Lib "gdi32" _
(ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, _
ByVal crColor As Long, ByVal fuFillType As Long) As Long

' --------------------------------------------------------------
' Windows API - For timing

Public Declare Function timeGetTime& Lib "winmm.dll" ()

' --------------------------------------------------------------
' Windows API - Faster then VB's Point -

Public Declare Function GetPixel Lib "gdi32" _
(ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long

'------------------------------------------------------------------------------

' Windows API - For playing WAV files

Public Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" _
(ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long

Public Const SND_SYNC = &H0
Public Const SND_ASYNC = &H1
Public Const SND_NODEFAULT = &H2
Public Const SND_LOOP = &H8
Public Const SND_NOSTOP = &H10
Public Const SND_PURGE = &H40

'- SND_SYNC specifies that the sound is played synchronously and the
'  function does not return until the sound ends.

'- SND_ASYNC specifies that the sound is played asynchronously and the
'  function returns immediately after beginning the sound.

'- SND_NODEFAULT specifies that if the sound cannot be found, the
'  function returns silently without playing the default sound.

'- SND_LOOP specifies that the sound will continue to play continuously
'  until PlaySound is called again with the lpszSoundName$ parameter
'  set to null. You must also specify the SND_ASYNC flag to loop sounds.

'- SND_NOSTOP specifies that if a sound is currently playing, the
'  function will immediately return False without playing the requested
'  sound.

'_ SND_PURGE Stop playback

' The PlaySound function returns True (-1) if the sound is played,
'  otherwise it returns False (0).

'-----------------------------------------------------------------------

'-----------------------------------------------------------------------
Global xNew, yNew, xOld, yOld ' Ball Picbox new & old top-left coords
Global xc, yc, zBallRad       ' Ball center coords & radius
Global culp                   ' Ball peripheral color
Global xp, yp, zalpha         ' Ball peripheral color coords & direction
Global zalphao                ' Ball's direction

Global zRAD, zXC, zYC         ' Top semi-circle

Global zTime, zdeltaT         ' Relative time & increment
Global zUx, zUy, zGrav        ' x & y velocites & gravity

Global zInvSpeed              ' Loop time delay in micro-secs

Global LPaddleUP As Boolean   ' Shift True or False
Global RPaddleUP As Boolean   ' Ctrl  True or False
Global LActUP As Boolean      ' Left paddle actually up
Global RActUP As Boolean      ' Right paddle actually up
Global DPaddleY, UPaddleY     ' Paddle location
Global LHitColor, RHitColor   ' Paddle hit zone colors
   
Global YourName$
Global Score, NumberOfBalls, ScoreAdd
Global HiScore
Global BallInPlay As Boolean

Global xPin, yPin             ' Firing pin coords

Global zLightUpTime           ' Obstacle light up time
Global ASound As Boolean
'Global redc As Byte, greenc As Byte, bluec As Byte

Global PathSpec$
Global Const pi# = 3.14159265
Global Const r2d# = 180 / pi#

Public Function zATan2(ByVal zy, ByVal zx)
' Find angle Atan from -pi#/2 to +pi#/2
'Global pi#
If zx <> 0 Then
   zATan2 = Atn(zy / zx)
   If (zx < 0) Then
      If (zy < 0) Then zATan2 = zATan2 - pi# Else zATan2 = zATan2 + pi#
   End If
Else
   If Abs(zy) > Abs(zx) Then   'Must be an overflow
      If zy > 0 Then zATan2 = pi# / 2 Else zATan2 = -pi# / 2
   Else
      zATan2 = 0   'Must be an underflow
   End If
End If
End Function



